diff -rupN keepalived-1.2.7/keepalived/core/smtp.c keepalived-1.2.7-unicast/keepalived/core/smtp.c
--- keepalived-1.2.7/keepalived/core/smtp.c	2012-08-17 01:21:28.000000000 +0200
+++ keepalived-1.2.7-unicast/keepalived/core/smtp.c	2013-05-24 10:12:36.532162900 +0200
@@ -75,39 +75,39 @@ struct {
 };
 
 static void
-free_smtp_all(smtp_thread_arg * smtp_arg)
+free_smtp_all(smtp_t * smtp)
 {
-	FREE(smtp_arg->buffer);
-	FREE(smtp_arg->subject);
-	FREE(smtp_arg->body);
-	FREE(smtp_arg);
+	FREE(smtp->buffer);
+	FREE(smtp->subject);
+	FREE(smtp->body);
+	FREE(smtp);
 }
 
 static char *
-fetch_next_email(smtp_thread_arg * smtp_arg)
+fetch_next_email(smtp_t * smtp)
 {
-	return list_element(global_data->email, smtp_arg->email_it);
+	return list_element(global_data->email, smtp->email_it);
 }
 
 /* layer4 connection handlers */
 static int
 connection_error(thread_t * thread)
 {
-	smtp_thread_arg *smtp_arg = THREAD_ARG(thread);
+	smtp_t *smtp = THREAD_ARG(thread);
 
 	log_message(LOG_INFO, "SMTP connection ERROR to [%s]:%d."
 			    , inet_sockaddrtos(&global_data->smtp_server), SMTP_PORT);
-	free_smtp_all(smtp_arg);
+	free_smtp_all(smtp);
 	return 0;
 }
 static int
 connection_timeout(thread_t * thread)
 {
-	smtp_thread_arg *smtp_arg = THREAD_ARG(thread);
+	smtp_t *smtp = THREAD_ARG(thread);
 
 	log_message(LOG_INFO, "Timeout connecting SMTP server [%s]:%d."
 			    , inet_sockaddrtos(&global_data->smtp_server), SMTP_PORT);
-	free_smtp_all(smtp_arg);
+	free_smtp_all(smtp);
 	return 0;
 }
 static int
@@ -132,14 +132,14 @@ connection_in_progress(thread_t * thread
 static int
 connection_success(thread_t * thread)
 {
-	smtp_thread_arg *smtp_arg = THREAD_ARG(thread);
+	smtp_t *smtp = THREAD_ARG(thread);
 
 	log_message(LOG_INFO, "Remote SMTP server [%s]:%d connected."
 			    , inet_sockaddrtos(&global_data->smtp_server), SMTP_PORT);
 
-	smtp_arg->stage = connect_success;
-	thread_add_read(thread->master, smtp_read_thread, smtp_arg,
-			smtp_arg->fd, global_data->smtp_connection_to);
+	smtp->stage = connect_success;
+	thread_add_read(thread->master, smtp_read_thread, smtp,
+			smtp->fd, global_data->smtp_connection_to);
 	return 0;
 }
 
@@ -147,13 +147,13 @@ connection_success(thread_t * thread)
 static int
 smtp_read_thread(thread_t * thread)
 {
-	smtp_thread_arg *smtp_arg;
+	smtp_t *smtp;
 	char *buffer;
 	char *reply;
 	int rcv_buffer_size = 0;
 	int status = -1;
 
-	smtp_arg = THREAD_ARG(thread);
+	smtp = THREAD_ARG(thread);
 
 	if (thread->type == THREAD_READ_TIMEOUT) {
 		log_message(LOG_INFO, "Timeout reading data to remote SMTP server [%s]:%d."
@@ -162,10 +162,10 @@ smtp_read_thread(thread_t * thread)
 		return -1;
 	}
 
-	buffer = smtp_arg->buffer;
+	buffer = smtp->buffer;
 
-	rcv_buffer_size = read(thread->u.fd, buffer + smtp_arg->buflen,
-			       SMTP_BUFFER_LENGTH - smtp_arg->buflen);
+	rcv_buffer_size = read(thread->u.fd, buffer + smtp->buflen,
+			       SMTP_BUFFER_LENGTH - smtp->buflen);
 
 	if (rcv_buffer_size == -1) {
 		if (errno == EAGAIN)
@@ -177,33 +177,33 @@ smtp_read_thread(thread_t * thread)
 	}
 
 	/* received data overflow buffer size ? */
-	if (smtp_arg->buflen >= SMTP_BUFFER_MAX) {
+	if (smtp->buflen >= SMTP_BUFFER_MAX) {
 		log_message(LOG_INFO, "Received buffer from remote SMTP server [%s]:%d"
 				      " overflow our get read buffer length."
 				    , inet_sockaddrtos(&global_data->smtp_server), SMTP_PORT);
 		SMTP_FSM_READ(QUIT, thread, 0);
 		return 0;
 	} else {
-		smtp_arg->buflen += rcv_buffer_size;
-		buffer[smtp_arg->buflen] = 0;	/* NULL terminate */
+		smtp->buflen += rcv_buffer_size;
+		buffer[smtp->buflen] = 0;	/* NULL terminate */
 	}
 
       end:
 
 	/* parse the buffer, finding the last line of the response for the code */
 	reply = buffer;
-	while (reply < buffer + smtp_arg->buflen) {
+	while (reply < buffer + smtp->buflen) {
 		char *p;
 
 		p = strstr(reply, "\r\n");
 		if (!p) {
 			memmove(buffer, reply,
-				smtp_arg->buflen - (reply - buffer));
-			smtp_arg->buflen -= (reply - buffer);
-			buffer[smtp_arg->buflen] = 0;
+				smtp->buflen - (reply - buffer));
+			smtp->buflen -= (reply - buffer);
+			buffer[smtp->buflen] = 0;
 
 			thread_add_read(thread->master, smtp_read_thread,
-					smtp_arg, thread->u.fd,
+					smtp, thread->u.fd,
 					global_data->smtp_connection_to);
 			return 0;
 		}
@@ -220,22 +220,22 @@ smtp_read_thread(thread_t * thread)
 		break;
 	}
 
-	memmove(buffer, reply, smtp_arg->buflen - (reply - buffer));
-	smtp_arg->buflen -= (reply - buffer);
-	buffer[smtp_arg->buflen] = 0;
+	memmove(buffer, reply, smtp->buflen - (reply - buffer));
+	smtp->buflen -= (reply - buffer);
+	buffer[smtp->buflen] = 0;
 
 	if (status == -1) {
-		thread_add_read(thread->master, smtp_read_thread, smtp_arg,
+		thread_add_read(thread->master, smtp_read_thread, smtp,
 				thread->u.fd, global_data->smtp_connection_to);
 		return 0;
 	}
 
-	SMTP_FSM_READ(smtp_arg->stage, thread, status);
+	SMTP_FSM_READ(smtp->stage, thread, status);
 
 	/* Registering next smtp command processing thread */
-	if (smtp_arg->stage != ERROR) {
-		thread_add_write(thread->master, smtp_send_thread, smtp_arg,
-				 smtp_arg->fd, global_data->smtp_connection_to);
+	if (smtp->stage != ERROR) {
+		thread_add_write(thread->master, smtp_send_thread, smtp,
+				 smtp->fd, global_data->smtp_connection_to);
 	} else {
 		log_message(LOG_INFO, "Can not read data from remote SMTP server [%s]:%d."
 				    , inet_sockaddrtos(&global_data->smtp_server), SMTP_PORT);
@@ -248,7 +248,7 @@ smtp_read_thread(thread_t * thread)
 static int
 smtp_send_thread(thread_t * thread)
 {
-	smtp_thread_arg *smtp_arg = THREAD_ARG(thread);
+	smtp_t *smtp = THREAD_ARG(thread);
 
 	if (thread->type == THREAD_WRITE_TIMEOUT) {
 		log_message(LOG_INFO, "Timeout sending data to remote SMTP server [%s]:%d."
@@ -257,22 +257,22 @@ smtp_send_thread(thread_t * thread)
 		return 0;
 	}
 
-	SMTP_FSM_SEND(smtp_arg->stage, thread);
+	SMTP_FSM_SEND(smtp->stage, thread);
 
 	/* Handle END command */
-	if (smtp_arg->stage == END) {
+	if (smtp->stage == END) {
 		SMTP_FSM_READ(QUIT, thread, 0);
 		return 0;
 	}
 
 	/* Registering next smtp command processing thread */
-	if (smtp_arg->stage != ERROR) {
-		thread_add_read(thread->master, smtp_read_thread, smtp_arg,
+	if (smtp->stage != ERROR) {
+		thread_add_read(thread->master, smtp_read_thread, smtp,
 				thread->u.fd, global_data->smtp_connection_to);
 	} else {
-		log_message(LOG_INFO,
-		       "Can not send data to remote SMTP server [%s]:%d.",
-		       inet_sockaddrtos(&global_data->smtp_server), SMTP_PORT);
+		log_message(LOG_INFO, "Can not send data to remote SMTP server [%s]:%d."
+				    , inet_sockaddrtos(&global_data->smtp_server)
+				    , SMTP_PORT);
 		SMTP_FSM_READ(QUIT, thread, 0);
 	}
 
@@ -282,15 +282,16 @@ smtp_send_thread(thread_t * thread)
 static int
 connection_code(thread_t * thread, int status)
 {
-	smtp_thread_arg *smtp_arg = THREAD_ARG(thread);
+	smtp_t *smtp = THREAD_ARG(thread);
 
 	if (status == 220) {
-		smtp_arg->stage++;
+		smtp->stage++;
 	} else {
 		log_message(LOG_INFO, "Error connecting SMTP server[%s]:%d."
-		       " SMTP status code = %d", inet_sockaddrtos(&global_data->smtp_server),
-		       SMTP_PORT, status);
-		smtp_arg->stage = ERROR;
+				      " SMTP status code = %d"
+				    , inet_sockaddrtos(&global_data->smtp_server)
+				    , SMTP_PORT, status);
+		smtp->stage = ERROR;
 	}
 
 	return 0;
@@ -300,13 +301,13 @@ connection_code(thread_t * thread, int s
 static int
 helo_cmd(thread_t * thread)
 {
-	smtp_thread_arg *smtp_arg = THREAD_ARG(thread);
+	smtp_t *smtp = THREAD_ARG(thread);
 	char *buffer;
 
 	buffer = (char *) MALLOC(SMTP_BUFFER_MAX);
 	snprintf(buffer, SMTP_BUFFER_MAX, SMTP_HELO_CMD, get_local_name());
 	if (send(thread->u.fd, buffer, strlen(buffer), 0) == -1)
-		smtp_arg->stage = ERROR;
+		smtp->stage = ERROR;
 	FREE(buffer);
 
 	return 0;
@@ -314,16 +315,16 @@ helo_cmd(thread_t * thread)
 static int
 helo_code(thread_t * thread, int status)
 {
-	smtp_thread_arg *smtp_arg = THREAD_ARG(thread);
+	smtp_t *smtp = THREAD_ARG(thread);
 
 	if (status == 250) {
-		smtp_arg->stage++;
+		smtp->stage++;
 	} else {
-		log_message(LOG_INFO,
-		       "Error processing HELO cmd on SMTP server [%s]:%d."
-		       " SMTP status code = %d", inet_sockaddrtos(&global_data->smtp_server),
-		       SMTP_PORT, status);
-		smtp_arg->stage = ERROR;
+		log_message(LOG_INFO, "Error processing HELO cmd on SMTP server [%s]:%d."
+				      " SMTP status code = %d"
+				    , inet_sockaddrtos(&global_data->smtp_server)
+				    , SMTP_PORT, status);
+		smtp->stage = ERROR;
 	}
 
 	return 0;
@@ -333,13 +334,13 @@ helo_code(thread_t * thread, int status)
 static int
 mail_cmd(thread_t * thread)
 {
-	smtp_thread_arg *smtp_arg = THREAD_ARG(thread);
+	smtp_t *smtp = THREAD_ARG(thread);
 	char *buffer;
 
 	buffer = (char *) MALLOC(SMTP_BUFFER_MAX);
 	snprintf(buffer, SMTP_BUFFER_MAX, SMTP_MAIL_CMD, global_data->email_from);
 	if (send(thread->u.fd, buffer, strlen(buffer), 0) == -1)
-		smtp_arg->stage = ERROR;
+		smtp->stage = ERROR;
 	FREE(buffer);
 
 	return 0;
@@ -347,16 +348,16 @@ mail_cmd(thread_t * thread)
 static int
 mail_code(thread_t * thread, int status)
 {
-	smtp_thread_arg *smtp_arg = THREAD_ARG(thread);
+	smtp_t *smtp = THREAD_ARG(thread);
 
 	if (status == 250) {
-		smtp_arg->stage++;
+		smtp->stage++;
 	} else {
-		log_message(LOG_INFO,
-		       "Error processing MAIL cmd on SMTP server [%s]:%d."
-		       " SMTP status code = %d", inet_sockaddrtos(&global_data->smtp_server),
-		       SMTP_PORT, status);
-		smtp_arg->stage = ERROR;
+		log_message(LOG_INFO, "Error processing MAIL cmd on SMTP server [%s]:%d."
+				      " SMTP status code = %d"
+				    , inet_sockaddrtos(&global_data->smtp_server)
+				    , SMTP_PORT, status);
+		smtp->stage = ERROR;
 	}
 
 	return 0;
@@ -366,7 +367,7 @@ mail_code(thread_t * thread, int status)
 static int
 rcpt_cmd(thread_t * thread)
 {
-	smtp_thread_arg *smtp_arg = THREAD_ARG(thread);
+	smtp_t *smtp = THREAD_ARG(thread);
 	char *buffer;
 	char *fetched_email;
 
@@ -374,11 +375,11 @@ rcpt_cmd(thread_t * thread)
 	/* We send RCPT TO command multiple time to add all our email receivers.
 	 * --rfc821.3.1
 	 */
-	fetched_email = fetch_next_email(smtp_arg);
+	fetched_email = fetch_next_email(smtp);
 
 	snprintf(buffer, SMTP_BUFFER_MAX, SMTP_RCPT_CMD, fetched_email);
 	if (send(thread->u.fd, buffer, strlen(buffer), 0) == -1)
-		smtp_arg->stage = ERROR;
+		smtp->stage = ERROR;
 	FREE(buffer);
 
 	return 0;
@@ -386,22 +387,22 @@ rcpt_cmd(thread_t * thread)
 static int
 rcpt_code(thread_t * thread, int status)
 {
-	smtp_thread_arg *smtp_arg = THREAD_ARG(thread);
+	smtp_t *smtp = THREAD_ARG(thread);
 	char *fetched_email;
 
 	if (status == 250) {
-		smtp_arg->email_it++;
+		smtp->email_it++;
 
-		fetched_email = fetch_next_email(smtp_arg);
+		fetched_email = fetch_next_email(smtp);
 
 		if (!fetched_email)
-			smtp_arg->stage++;
+			smtp->stage++;
 	} else {
-		log_message(LOG_INFO,
-		       "Error processing RCPT cmd on SMTP server [%s]:%d."
-		       " SMTP status code = %d", inet_sockaddrtos(&global_data->smtp_server),
-		       SMTP_PORT, status);
-		smtp_arg->stage = ERROR;
+		log_message(LOG_INFO, "Error processing RCPT cmd on SMTP server [%s]:%d."
+				      " SMTP status code = %d"
+				    , inet_sockaddrtos(&global_data->smtp_server)
+				    , SMTP_PORT, status);
+		smtp->stage = ERROR;
 	}
 
 	return 0;
@@ -411,25 +412,25 @@ rcpt_code(thread_t * thread, int status)
 static int
 data_cmd(thread_t * thread)
 {
-	smtp_thread_arg *smtp_arg = THREAD_ARG(thread);
+	smtp_t *smtp = THREAD_ARG(thread);
 
 	if (send(thread->u.fd, SMTP_DATA_CMD, strlen(SMTP_DATA_CMD), 0) == -1)
-		smtp_arg->stage = ERROR;
+		smtp->stage = ERROR;
 	return 0;
 }
 static int
 data_code(thread_t * thread, int status)
 {
-	smtp_thread_arg *smtp_arg = THREAD_ARG(thread);
+	smtp_t *smtp = THREAD_ARG(thread);
 
 	if (status == 354) {
-		smtp_arg->stage++;
+		smtp->stage++;
 	} else {
-		log_message(LOG_INFO,
-		       "Error processing DATA cmd on SMTP server [%s]:%d."
-		       " SMTP status code = %d", inet_sockaddrtos(&global_data->smtp_server),
-		       SMTP_PORT, status);
-		smtp_arg->stage = ERROR;
+		log_message(LOG_INFO, "Error processing DATA cmd on SMTP server [%s]:%d."
+				      " SMTP status code = %d"
+				    , inet_sockaddrtos(&global_data->smtp_server)
+				    , SMTP_PORT, status);
+		smtp->stage = ERROR;
 	}
 
 	return 0;
@@ -442,7 +443,7 @@ data_code(thread_t * thread, int status)
 static int
 body_cmd(thread_t * thread)
 {
-	smtp_thread_arg *smtp_arg = THREAD_ARG(thread);
+	smtp_t *smtp = THREAD_ARG(thread);
 	char *buffer;
 	char rfc822[80];
 	time_t tm;
@@ -453,23 +454,22 @@ body_cmd(thread_t * thread)
 	strftime(rfc822, sizeof(rfc822), "%a, %d %b %Y %H:%M:%S %z", gmtime(&tm));
 
 	snprintf(buffer, SMTP_BUFFER_MAX, SMTP_HEADERS_CMD,
-		 rfc822, global_data->email_from, smtp_arg->subject);
+		 rfc822, global_data->email_from, smtp->subject);
 
 	/* send the subject field */
 	if (send(thread->u.fd, buffer, strlen(buffer), 0) == -1)
-		smtp_arg->stage = ERROR;
+		smtp->stage = ERROR;
 
 	memset(buffer, 0, SMTP_BUFFER_MAX);
-	snprintf(buffer, SMTP_BUFFER_MAX, SMTP_BODY_CMD, smtp_arg->body);
+	snprintf(buffer, SMTP_BUFFER_MAX, SMTP_BODY_CMD, smtp->body);
 
 	/* send the the body field */
 	if (send(thread->u.fd, buffer, strlen(buffer), 0) == -1)
-		smtp_arg->stage = ERROR;
+		smtp->stage = ERROR;
 
 	/* send the sending dot */
-	if (send(thread->u.fd, SMTP_SEND_CMD, strlen(SMTP_SEND_CMD), 0)
-	    == -1)
-		smtp_arg->stage = ERROR;
+	if (send(thread->u.fd, SMTP_SEND_CMD, strlen(SMTP_SEND_CMD), 0) == -1)
+		smtp->stage = ERROR;
 
 	FREE(buffer);
 	return 0;
@@ -477,17 +477,17 @@ body_cmd(thread_t * thread)
 static int
 body_code(thread_t * thread, int status)
 {
-	smtp_thread_arg *smtp_arg = THREAD_ARG(thread);
+	smtp_t *smtp = THREAD_ARG(thread);
 
 	if (status == 250) {
 		log_message(LOG_INFO, "SMTP alert successfully sent.");
-		smtp_arg->stage++;
+		smtp->stage++;
 	} else {
-		log_message(LOG_INFO,
-		       "Error processing DOT cmd on SMTP server [%s]:%d."
-		       " SMTP status code = %d", inet_sockaddrtos(&global_data->smtp_server),
-		       SMTP_PORT, status);
-		smtp_arg->stage = ERROR;
+		log_message(LOG_INFO, "Error processing DOT cmd on SMTP server [%s]:%d."
+				      " SMTP status code = %d"
+				    , inet_sockaddrtos(&global_data->smtp_server)
+				    , SMTP_PORT, status);
+		smtp->stage = ERROR;
 	}
 
 	return 0;
@@ -497,81 +497,84 @@ body_code(thread_t * thread, int status)
 static int
 quit_cmd(thread_t * thread)
 {
-	smtp_thread_arg *smtp_arg = THREAD_ARG(thread);
+	smtp_t *smtp = THREAD_ARG(thread);
 
 	if (send(thread->u.fd, SMTP_QUIT_CMD, strlen(SMTP_QUIT_CMD), 0) == -1)
-		smtp_arg->stage = ERROR;
+		smtp->stage = ERROR;
 	else
-		smtp_arg->stage++;
+		smtp->stage++;
 	return 0;
 }
 static int
 quit_code(thread_t * thread, int status)
 {
-	smtp_thread_arg *smtp_arg = THREAD_ARG(thread);
+	smtp_t *smtp = THREAD_ARG(thread);
 
 	/* final state, we are disconnected from the remote host */
-	free_smtp_all(smtp_arg);
+	free_smtp_all(smtp);
 	close(thread->u.fd);
 	return 0;
 }
 
 /* connect remote SMTP server */
 static void
-smtp_connect(smtp_thread_arg * smtp_arg)
+smtp_connect(smtp_t * smtp)
 {
 	enum connect_result status;
 
-	if ((smtp_arg->fd = socket(global_data->smtp_server.ss_family, SOCK_STREAM, IPPROTO_TCP)) == -1) {
+	if ((smtp->fd = socket(global_data->smtp_server.ss_family, SOCK_STREAM, IPPROTO_TCP)) == -1) {
 		DBG("SMTP connect fail to create socket.");
-		free_smtp_all(smtp_arg);
+		free_smtp_all(smtp);
 		return;
 	}
 
-	status = tcp_connect(smtp_arg->fd, &global_data->smtp_server);
+	status = tcp_connect(smtp->fd, &global_data->smtp_server);
 
 	/* Handle connection status code */
-	thread_add_event(master, SMTP_FSM[status].send, smtp_arg, smtp_arg->fd);
+	thread_add_event(master, SMTP_FSM[status].send, smtp, smtp->fd);
 }
 
 /* Main entry point */
 void
-smtp_alert(real_server * rs, vrrp_rt * vrrp,
-	   vrrp_sgroup * vgroup, const char *subject, const char *body)
+smtp_alert(real_server_t * rs, vrrp_t * vrrp,
+	   vrrp_sgroup_t * vgroup, const char *subject, const char *body)
 {
-	smtp_thread_arg *smtp_arg;
+	smtp_t *smtp;
 
 	/* Only send mail if email specified */
 	if (!LIST_ISEMPTY(global_data->email) && global_data->smtp_server.ss_family != 0) {
 		/* allocate & initialize smtp argument data structure */
-		smtp_arg = (smtp_thread_arg *) MALLOC(sizeof (smtp_thread_arg));
-		smtp_arg->subject = (char *) MALLOC(MAX_HEADERS_LENGTH);
-		smtp_arg->body = (char *) MALLOC(MAX_BODY_LENGTH);
-		smtp_arg->buffer = (char *) MALLOC(SMTP_BUFFER_MAX);
+		smtp = (smtp_t *) MALLOC(sizeof(smtp_t));
+		smtp->subject = (char *) MALLOC(MAX_HEADERS_LENGTH);
+		smtp->body = (char *) MALLOC(MAX_BODY_LENGTH);
+		smtp->buffer = (char *) MALLOC(SMTP_BUFFER_MAX);
 
 		/* format subject if rserver is specified */
 		if (rs) {
-			snprintf(smtp_arg->subject, MAX_HEADERS_LENGTH, "[%s] Realserver [%s]:%d - %s"
-				 , global_data->router_id, inet_sockaddrtos(&rs->addr)
-				 , ntohs(inet_sockaddrport(&rs->addr))
-				 , subject);
+			snprintf(smtp->subject, MAX_HEADERS_LENGTH, "[%s] Realserver [%s]:%d - %s"
+					      , global_data->router_id
+					      , inet_sockaddrtos(&rs->addr)
+					      , ntohs(inet_sockaddrport(&rs->addr))
+					      , subject);
 		} else if (vrrp)
-			snprintf(smtp_arg->subject, MAX_HEADERS_LENGTH,
-				 "[%s] VRRP Instance %s - %s",
-				 global_data->router_id, vrrp->iname, subject);
+			snprintf(smtp->subject, MAX_HEADERS_LENGTH, "[%s] VRRP Instance %s - %s"
+					      , global_data->router_id
+					      , vrrp->iname
+					      , subject);
 		else if (vgroup)
-			snprintf(smtp_arg->subject, MAX_HEADERS_LENGTH,
-				 "[%s] VRRP Group %s - %s",
-				 global_data->router_id, vgroup->gname, subject);
+			snprintf(smtp->subject, MAX_HEADERS_LENGTH, "[%s] VRRP Group %s - %s"
+					      , global_data->router_id
+					      , vgroup->gname
+					      , subject);
 		else if (global_data->router_id)
-			snprintf(smtp_arg->subject, MAX_HEADERS_LENGTH,
-				 "[%s] %s", global_data->router_id, subject);
+			snprintf(smtp->subject, MAX_HEADERS_LENGTH, "[%s] %s"
+					      , global_data->router_id
+					      , subject);
 		else
-			snprintf(smtp_arg->subject, MAX_HEADERS_LENGTH, "%s",
-				 subject);
+			snprintf(smtp->subject, MAX_HEADERS_LENGTH, "%s", subject);
 
-		strncpy(smtp_arg->body, body, MAX_BODY_LENGTH);
+		strncpy(smtp->body, body, MAX_BODY_LENGTH);
 
-		smtp_connect(smtp_arg);
+		smtp_connect(smtp);
 	}
 }
diff -rupN keepalived-1.2.7/keepalived/include/check_api.h keepalived-1.2.7-unicast/keepalived/include/check_api.h
--- keepalived-1.2.7/keepalived/include/check_api.h	2012-08-29 00:05:12.000000000 +0200
+++ keepalived-1.2.7-unicast/keepalived/include/check_api.h	2013-05-24 10:12:36.540163300 +0200
@@ -29,15 +29,15 @@
 
 /* Checkers structure definition */
 typedef struct _checker {
-	void (*free_func) (void *);
-	void (*dump_func) (void *);
-	int (*launch) (struct _thread *);
-	int (*plugin_launch) (void *);
-	virtual_server *vs;	/* pointer to the checker thread virtualserver */
-	real_server *rs;	/* pointer to the checker thread realserver */
-	void *data;
-	checker_id_t id;	/* Checker identifier */
-	int enabled;		/* Activation flag */
+	void				(*free_func) (void *);
+	void				(*dump_func) (void *);
+	int				(*launch) (struct _thread *);
+	int				(*plugin_launch) (void *);
+	virtual_server_t		*vs;	/* pointer to the checker thread virtualserver */
+	real_server_t			*rs;	/* pointer to the checker thread realserver */
+	void				*data;
+	checker_id_t			id;	/* Checker identifier */
+	int				enabled;/* Activation flag */
 } checker_t;
 
 /* Checkers queue */
diff -rupN keepalived-1.2.7/keepalived/include/check_data.h keepalived-1.2.7-unicast/keepalived/include/check_data.h
--- keepalived-1.2.7/keepalived/include/check_data.h	2012-08-29 00:05:12.000000000 +0200
+++ keepalived-1.2.7-unicast/keepalived/include/check_data.h	2013-05-24 10:12:36.544163600 +0200
@@ -55,96 +55,96 @@ typedef unsigned int checker_id_t;
 #define KEEPALIVED_DEFAULT_DELAY	(60 * TIMER_HZ) 
 
 /* SSL specific data */
-typedef struct ssl_data {
-	int enable;
-	int strong_check;
-	SSL_CTX *ctx;
-	SSL_METHOD *meth;
-	char *password;
-	char *cafile;
-	char *certfile;
-	char *keyfile;
+typedef struct _ssl_data {
+	int				enable;
+	int				strong_check;
+	SSL_CTX				*ctx;
+	SSL_METHOD			*meth;
+	char				*password;
+	char				*cafile;
+	char				*certfile;
+	char				*keyfile;
 } ssl_data_t;
 
 /* Real Server definition */
 typedef struct _real_server {
-	struct sockaddr_storage	addr;
-	int weight;
-	int iweight;		/* Initial weight */
+	struct sockaddr_storage		addr;
+	int				weight;
+	int				iweight;	/* Initial weight */
 #ifdef _KRNL_2_6_
-	uint32_t u_threshold;   /* Upper connection limit. */
-	uint32_t l_threshold;   /* Lower connection limit. */
+	uint32_t			u_threshold;   /* Upper connection limit. */
+	uint32_t			l_threshold;   /* Lower connection limit. */
 #endif
-	int inhibit;		/* Set weight to 0 instead of removing
-				 * the service from IPVS topology.
-				 */
-	char *notify_up;	/* Script to launch when RS is added to LVS */
-	char *notify_down;	/* Script to launch when RS is removed from LVS */
-	int alive;
-	list failed_checkers;	/* List of failed checkers */
-	int set;		/* in the IPVS table */
+	int				inhibit;	/* Set weight to 0 instead of removing
+							 * the service from IPVS topology.
+							 */
+	char				*notify_up;	/* Script to launch when RS is added to LVS */
+	char				*notify_down;	/* Script to launch when RS is removed from LVS */
+	int				alive;
+	list				failed_checkers;/* List of failed checkers */
+	int				set;		/* in the IPVS table */
 #if defined(_WITH_SNMP_) && defined(_KRNL_2_6_) && defined(_WITH_LVS_)
 	/* Statistics */
-	uint32_t activeconns;  /* active connections */
-	uint32_t inactconns;   /* inactive connections */
-	uint32_t persistconns; /* persistent connections */
-	struct ip_vs_stats_user stats;
+	uint32_t			activeconns;	/* active connections */
+	uint32_t			inactconns;	/* inactive connections */
+	uint32_t			persistconns;	/* persistent connections */
+	struct ip_vs_stats_user		stats;
 #endif
-} real_server;
+} real_server_t;
 
 /* Virtual Server group definition */
 typedef struct _virtual_server_group_entry {
-	struct sockaddr_storage	addr;
-	uint8_t range;
-	uint32_t vfwmark;
-	int alive;
-} virtual_server_group_entry;
+	struct sockaddr_storage		addr;
+	uint8_t				range;
+	uint32_t			vfwmark;
+	int				alive;
+} virtual_server_group_entry_t;
 
 typedef struct _virtual_server_group {
-	char *gname;
-	list addr_ip;
-	list range;
-	list vfwmark;
-} virtual_server_group;
+	char				*gname;
+	list				addr_ip;
+	list				range;
+	list				vfwmark;
+} virtual_server_group_t;
 
 /* Virtual Server definition */
 typedef struct _virtual_server {
-	char *vsgname;
-	struct sockaddr_storage	addr;
-	real_server *s_svr;
-	uint32_t vfwmark;
-	uint16_t service_type;
-	long delay_loop;
-	int ha_suspend;
-	char sched[SCHED_MAX_LENGTH];
-	char timeout_persistence[MAX_TIMEOUT_LENGTH];
-	unsigned loadbalancing_kind;
-	uint32_t nat_mask;
-	uint32_t granularity_persistence;
-	char *virtualhost;
-	list rs;
-	int alive;
-	unsigned alpha;			/* Alpha mode enabled. */
-	unsigned omega;			/* Omega mode enabled. */
-	char *quorum_up;		/* A hook to call when the VS gains quorum. */
-	char * quorum_down;		/* A hook to call when the VS loses quorum. */
-	long unsigned quorum;		/* Minimum live RSs to consider VS up. */
+	char				*vsgname;
+	struct sockaddr_storage		addr;
+	real_server_t			*s_svr;
+	uint32_t			vfwmark;
+	uint16_t			service_type;
+	long				delay_loop;
+	int				ha_suspend;
+	char				sched[SCHED_MAX_LENGTH];
+	char				timeout_persistence[MAX_TIMEOUT_LENGTH];
+	unsigned			loadbalancing_kind;
+	uint32_t			nat_mask;
+	uint32_t			granularity_persistence;
+	char				*virtualhost;
+	list				rs;
+	int				alive;
+	unsigned			alpha;		/* Alpha mode enabled. */
+	unsigned			omega;		/* Omega mode enabled. */
+	char				*quorum_up;	/* A hook to call when the VS gains quorum. */
+	char				*quorum_down;	/* A hook to call when the VS loses quorum. */
+	long unsigned			quorum;		/* Minimum live RSs to consider VS up. */
 
-	long unsigned hysteresis;	/* up/down events "lag" WRT quorum. */
-	unsigned quorum_state;		/* Reflects result of the last transition done. */
+	long unsigned			hysteresis;	/* up/down events "lag" WRT quorum. */
+	unsigned			quorum_state;	/* Reflects result of the last transition done. */
 #if defined(_WITH_SNMP_) && defined(_KRNL_2_6_) && defined(_WITH_LVS_)
 	/* Statistics */
-	time_t lastupdated;
-	struct ip_vs_stats_user stats;
+	time_t				lastupdated;
+	struct ip_vs_stats_user		stats;
 #endif
-} virtual_server;
+} virtual_server_t;
 
 /* Configuration data root */
-typedef struct _check_conf_data {
-	ssl_data_t *ssl;
-	list vs_group;
-	list vs;
-} check_conf_data;
+typedef struct _check_data {
+	ssl_data_t			*ssl;
+	list				vs_group;
+	list				vs;
+} check_data_t;
 
 /* inline stuff */
 static inline int __ip6_addr_equal(const struct in6_addr *a1,
@@ -228,8 +228,8 @@ static inline int inaddr_equal(sa_family
 			 (X)->iweight   == (Y)->iweight)
 
 /* Global vars exported */
-extern check_conf_data *check_data;
-extern check_conf_data *old_check_data;
+extern check_data_t *check_data;
+extern check_data_t *old_check_data;
 
 /* prototypes */
 extern ssl_data_t *alloc_ssl(void);
@@ -242,8 +242,8 @@ extern void alloc_ssvr(char *, char *);
 extern void alloc_group(char *);
 extern void alloc_rsgroup(char *, char *);
 extern void set_rsgroup(char *);
-extern check_conf_data *alloc_check_data(void);
-extern void free_check_data(check_conf_data *);
-extern void dump_check_data(check_conf_data *);
+extern check_data_t *alloc_check_data(void);
+extern void free_check_data(check_data_t *);
+extern void dump_check_data(check_data_t *);
 
 #endif
diff -rupN keepalived-1.2.7/keepalived/include/check_http.h keepalived-1.2.7-unicast/keepalived/include/check_http.h
--- keepalived-1.2.7/keepalived/include/check_http.h	2012-08-13 20:50:25.000000000 +0200
+++ keepalived-1.2.7-unicast/keepalived/include/check_http.h	2013-05-24 10:12:36.546163700 +0200
@@ -39,38 +39,38 @@
 /* Checker argument structure  */
 /* ssl specific thread arguments defs */
 typedef struct _request {
-	char *buffer;
-	char *extracted;
-	int error;
-	int status_code;
-	int len;
-	SSL *ssl;
-	BIO *bio;
-	MD5_CTX context;
+	char				*buffer;
+	char				*extracted;
+	int				error;
+	int				status_code;
+	int				len;
+	SSL				*ssl;
+	BIO				*bio;
+	MD5_CTX				context;
 } request_t;
 
 /* http specific thread arguments defs */
-typedef struct _http_arg {
-	int retry_it;		/* current number of get retry */
-	int url_it;		/* current url checked index */
-	request_t *req;		/* GET buffer and SSL args */
-} http_arg_t ;
+typedef struct _http {
+	int				retry_it;	/* current number of get retry */
+	int				url_it;		/* current url checked index */
+	request_t			*req;		/* GET buffer and SSL args */
+} http_t ;
 
 typedef struct _url {
-	char *path;
-	char *digest;
-	int status_code;
+	char				*path;
+	char				*digest;
+	int				status_code;
 } url_t;
 
 typedef struct _http_checker {
-	int proto;
-	struct sockaddr_storage dst;
-	struct sockaddr_storage bindto;
-	long connection_to;
-	int nb_get_retry;
-	long delay_before_retry;
-	list url;
-	http_arg_t *arg;
+	int				proto;
+	struct sockaddr_storage		dst;
+	struct sockaddr_storage		bindto;
+	long				connection_to;
+	int				nb_get_retry;
+	long				delay_before_retry;
+	list				url;
+	http_t				*arg;
 } http_checker_t;
 
 /* global defs */
diff -rupN keepalived-1.2.7/keepalived/include/check_snmp.h keepalived-1.2.7-unicast/keepalived/include/check_snmp.h
--- keepalived-1.2.7/keepalived/include/check_snmp.h	2012-08-13 20:50:25.000000000 +0200
+++ keepalived-1.2.7-unicast/keepalived/include/check_snmp.h	2013-05-24 10:12:36.551164000 +0200
@@ -126,7 +126,7 @@ do {									\
 /* Prototypes */
 extern void check_snmp_agent_init(void);
 extern void check_snmp_agent_close(void);
-extern void check_snmp_rs_trap(real_server *, virtual_server *);
-extern void check_snmp_quorum_trap(virtual_server *);
+extern void check_snmp_rs_trap(real_server_t *, virtual_server_t *);
+extern void check_snmp_quorum_trap(virtual_server_t *);
 
 #endif
diff -rupN keepalived-1.2.7/keepalived/include/global_data.h keepalived-1.2.7-unicast/keepalived/include/global_data.h
--- keepalived-1.2.7/keepalived/include/global_data.h	2012-08-17 01:21:28.000000000 +0200
+++ keepalived-1.2.7-unicast/keepalived/include/global_data.h	2013-05-24 10:12:36.555164200 +0200
@@ -39,30 +39,30 @@
 
 /* email link list */
 typedef struct _email {
-	char *addr;
-} email;
+	char				*addr;
+} email_t;
 
 /* Configuration data root */
-typedef struct _conf_data {
-	int linkbeat_use_polling;
-	char *router_id;
-	char *plugin_dir;
-	char *email_from;
-	struct sockaddr_storage smtp_server;
-	long smtp_connection_to;
-	list email;
+typedef struct _data {
+	int				linkbeat_use_polling;
+	char				*router_id;
+	char				*plugin_dir;
+	char				*email_from;
+	struct sockaddr_storage		smtp_server;
+	long				smtp_connection_to;
+	list				email;
 #ifdef _WITH_SNMP_
-	int enable_traps;
+	int				enable_traps;
 #endif
-} conf_data_t;
+} data_t;
 
 /* Global vars exported */
-extern conf_data_t *global_data; /* Global configuration data */
+extern data_t *global_data; /* Global configuration data */
 
 /* Prototypes */
 extern void alloc_email(char *);
-extern conf_data_t *alloc_global_data(void);
-extern void free_global_data(conf_data_t *);
-extern void dump_global_data(conf_data_t *);
+extern data_t *alloc_global_data(void);
+extern void free_global_data(data_t *);
+extern void dump_global_data(data_t *);
 
 #endif
diff -rupN keepalived-1.2.7/keepalived/include/ipvswrapper.h keepalived-1.2.7-unicast/keepalived/include/ipvswrapper.h
--- keepalived-1.2.7/keepalived/include/ipvswrapper.h	2012-08-13 20:50:25.000000000 +0200
+++ keepalived-1.2.7-unicast/keepalived/include/ipvswrapper.h	2013-05-24 10:12:36.557164300 +0200
@@ -91,9 +91,9 @@ do {						\
 /* prototypes */
 extern int ipvs_start(void);
 extern void ipvs_stop(void);
-extern virtual_server_group *ipvs_get_group_by_name(char *, list);
-extern int ipvs_group_remove_entry(virtual_server *, virtual_server_group_entry *);
-extern int ipvs_cmd(int, list, virtual_server *, real_server *);
+extern virtual_server_group_t *ipvs_get_group_by_name(char *, list);
+extern int ipvs_group_remove_entry(virtual_server_t *, virtual_server_group_entry_t *);
+extern int ipvs_cmd(int, list, virtual_server_t *, real_server_t *);
 extern int ipvs_syncd_cmd(int, char *, int, int);
 extern void ipvs_syncd_master(char *, int);
 extern void ipvs_syncd_backup(char *, int);
@@ -101,7 +101,7 @@ extern void ipvs_syncd_backup(char *, in
 #ifdef _KRNL_2_6_
 /* Refresh statistics at most every 5 seconds */
 #define STATS_REFRESH 5
-extern void ipvs_update_stats(virtual_server * vs);
+extern void ipvs_update_stats(virtual_server_t * vs);
 #endif
 
 #endif
